﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using GrapeCity.ActiveReports.Document;

namespace Ar_Silverlight.Web
{
    public class ReportCache
    {
        private static Dictionary<string, SectionDocument> _sectionDocuments = new Dictionary<string, SectionDocument>();

        public static SectionDocument GetSectionDocument(string id)
        {
            SectionDocument sd;
            _sectionDocuments.TryGetValue(id, out sd);
            return sd;
        }

        public static string AddSectionDocument(SectionDocument sd)
        {
            var id = Guid.NewGuid().ToString();
            _sectionDocuments.Add(id, sd);
            return id;
        }

        public static void RemoveSectionDocument(string id)
        {
            if (_sectionDocuments.ContainsKey(id))
            {
                _sectionDocuments.Remove(id);
            }
        }
    }
}