﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Net.Browser;
using System.IO;

namespace Ar_Silverlight
{
    public partial class MainPage : UserControl
    {
        private ReportStatus _reportStatus;
        private ServiceReference1.Service2Client _serv;
        public MainPage()
        {
            InitializeComponent();
            _reportStatus = new ReportStatus();
            this.Resources.Add("ReportStatus", _reportStatus);
            _serv = new ServiceReference1.Service2Client();
            _serv.NewReportCompleted += new EventHandler<ServiceReference1.NewReportCompletedEventArgs>(serv_NewReportCompleted);
        }

        private void viewer1_Loaded(object sender, RoutedEventArgs e)
        {
            _serv.NewReportAsync();            
        }

        void serv_NewReportCompleted(object sender, ServiceReference1.NewReportCompletedEventArgs e)
        {
            string url = e.Result;
            _reportStatus.ReportUrl = url;
            Uri serviceUri = new Uri(url, UriKind.Relative);
            WebClient downloader = new WebClient();
            downloader.OpenReadCompleted += new OpenReadCompletedEventHandler(downloader_OpenReadCompleted);
            downloader.OpenReadAsync(serviceUri);
        }

        void downloader_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                return;
            }
            
            Stream responseStream = e.Result;
            GrapeCity.Viewer.Common.StreamDocumentLoader sdl = 
                new GrapeCity.Viewer.Common.StreamDocumentLoader(responseStream, GrapeCity.Viewer.Common.DocumentFormat.Rdf);
            viewer1.LoadDocument(sdl);
        }

        private void viewer1_Unloaded(object sender, RoutedEventArgs e)
        {
            _serv.CloseReportAsync(_reportStatus.ReportUrl);
        }        


    }

}
