﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;

namespace Ar_Silverlight
{
    public class ReportStatus
    {
        public string ReportUrl
        {
            get;
            set;
        }
    }

    public class PrintCommand : ICommand
    {
        private static void SendRequestByIFrame(string src)
        {
            string id = "pdfprintiframe";
            HtmlElement element = HtmlPage.Document.GetElementById(id);
            if (element == null)
            {
                element = HtmlPage.Document.CreateElement("iframe");
                element.SetAttribute("id", id);
                element.SetStyleAttribute("visibility", "hidden");
                element.SetStyleAttribute("width", "1px");
                element.SetStyleAttribute("height", "1px");
                element.SetStyleAttribute("position", "fixed");
                element.SetStyleAttribute("left", "0");
                element.SetStyleAttribute("top", "0");
                HtmlPage.Document.Body.AppendChild(element);
            }

            element.SetAttribute("src", src);
        }

        private Action<ReportStatus> _action;

        public Action<ReportStatus> PrintAction
        {
            get
            {
                if (_action == null)
                {
                    _action = (rs) => SendRequestByIFrame(rs.ReportUrl+"&type=pdf&print=true");
                }

                return _action;
            }
        }

        #region ICommand Members

        public bool CanExecute(object parameter)
        {
            return PrintAction != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            PrintAction(parameter as ReportStatus);
        }

        #endregion
    }
}

